package dialog;

import Form.MainApp;
import static Form.MainApp.MainForm;
import Model.SocketClient;
import Model.SocketCuisinier;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultComboBoxModel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;
import shared.Message;

public class DialogLogin extends JDialog
{
  private final JPanel contentPanel = new JPanel();
  private JTextField txtUsername;
  private JPasswordField txtPassword;
  private JComboBox Categorie_jComboBox;
  public static boolean login = false;
  public static int user_id = 0;
  public static String username = "";
  public static String password = "";
  public static String user_level = "";
  public static String typeUser = "";
  public String UserNameX = "";
  public MainApp parentMainApp;

  
  public DialogLogin(MainApp parent, boolean  modal)
  {
     
      
      parentMainApp = parent;
      setDefaultCloseOperation(2);
      setVisible(true);
      
      addWindowListener(new WindowAdapter()
    {
      public void windowClosing(WindowEvent e)
      {
        System.exit(0);
      }
    });
    setTitle("Login All Users");
    setIconImage(Toolkit.getDefaultToolkit().getImage(DialogLogin.class.getResource("/images/office_women_red.png")));
    setBounds(100, 100, 450, 330);
    getContentPane().setLayout(new BorderLayout());
    this.contentPanel.setBackground(new Color(255, 218, 185));
    this.contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
    getContentPane().add(this.contentPanel, "Center");
    this.contentPanel.setLayout(null);
    
    JButton okButton = new JButton("OK");
    okButton.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent arg0)
      {
         typeUser = Categorie_jComboBox.getSelectedItem().toString();
         username = txtUsername.getText();
         char[] PassCharArray = txtPassword.getPassword();
         password = String.valueOf(PassCharArray);
         
         
         if(typeUser.equals("Cuisinier"))
         {
             try {
                 parentMainApp.cuisinier = new SocketCuisinier(MainForm);
                 parentMainApp.cuisinierThread = new Thread(parentMainApp.cuisinier);
                 parentMainApp.cuisinierThread.start();
                 
                 parentMainApp.cuisinier.send(new Message("login", "TempUser", typeUser, "SERVER"));
                 parentMainApp.cuisinier.send(new Message("login", username, password, "SERVER"));
                 parentMainApp.cuisinier.setUsername(username);
                 parentMainApp.cuisinier.setPassword(password);
             } catch (IOException ex) {
                 Logger.getLogger(DialogLogin.class.getName()).log(Level.SEVERE, null, ex);
             }
         }
         if(typeUser.equals("Serveur"))
         {
             try {
                 parentMainApp.client = new SocketClient(MainForm);
                 parentMainApp.clientThread = new Thread(parentMainApp.client);
                 parentMainApp.clientThread.start();
                 
                 parentMainApp.client.send(new Message("login", "TempUser", typeUser, "SERVER"));
                 parentMainApp.client.send(new Message("login", username, password, "SERVER"));
                 parentMainApp.client.setUsername(username);
                 parentMainApp.client.setPassword(password);
             }
             catch (IOException ex) {
                 Logger.getLogger(DialogLogin.class.getName()).log(Level.SEVERE, null, ex);
             }
         }
      }
    });
    okButton.setForeground(new Color(255, 0, 0));
    okButton.setIcon(new ImageIcon(DialogLogin.class.getResource("/images/button_ok.png")));
    okButton.setFont(new Font("Tahoma", 1, 14));
    okButton.setBackground(new Color(218, 165, 32));
    okButton.setBounds(88, 238, 127, 45);
    this.contentPanel.add(okButton);
    okButton.setActionCommand("OK");
    getRootPane().setDefaultButton(okButton);
    

    JButton cancelButton = new JButton("Cancel");
    cancelButton.setForeground(new Color(255, 0, 0));
    cancelButton.setIcon(new ImageIcon(DialogLogin.class.getResource("/images/button_cancel.png")));
    cancelButton.setFont(new Font("Tahoma", 1, 14));
    cancelButton.setBackground(new Color(238, 130, 238));
    cancelButton.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent arg0)
      {
        System.exit(0);
      }
    });
    cancelButton.setBounds(225, 238, 132, 45);
    this.contentPanel.add(cancelButton);
    cancelButton.setActionCommand("Cancel");
    
    JLabel lblCategorie = new JLabel("Catégorie :");
    lblCategorie.setForeground(Color.BLUE);
    lblCategorie.setFont(new Font("Tahoma", 1, 14));
    lblCategorie.setBounds(37, 50, 101, 16);
    this.contentPanel.add(lblCategorie);
    
    JLabel lblUsername = new JLabel("Username :");
    lblUsername.setForeground(Color.BLUE);
    lblUsername.setFont(new Font("Tahoma", 1, 14));
    lblUsername.setBounds(37, 102, 101, 16);
    this.contentPanel.add(lblUsername);
    
    JLabel lblPassword = new JLabel("Password :");
    lblPassword.setForeground(Color.BLUE);
    lblPassword.setFont(new Font("Tahoma", 1, 14));
    lblPassword.setBounds(37, 154, 101, 16);
    this.contentPanel.add(lblPassword);
    
    this.Categorie_jComboBox = new JComboBox();
    Categorie_jComboBox.setModel(new DefaultComboBoxModel(new String[] { "Cuisinier", "Serveur" }));
    this.Categorie_jComboBox.setBounds(184, 40, 151, 38);
    this.contentPanel.add(this.Categorie_jComboBox);
    
    
    this.txtUsername = new JTextField();
    this.txtUsername.setFocusable(true);
    this.txtUsername.setBounds(184, 92, 151, 38);
    this.contentPanel.add(this.txtUsername);
    this.txtUsername.setColumns(10);
    this.txtUsername.setText("mahdi");
    
    this.txtPassword = new JPasswordField();
    this.txtPassword.setBounds(184, 144, 151, 38);
    this.txtPassword.setText("pass");
    this.contentPanel.add(this.txtPassword);
    
    
  }
  
  private void saveLog()
  {
     System.out.println("SAVE LOG AUTHENTIFICATION USER");
      /* 
    try
    {
      String sql = "INSERT INTO tb_log(user_id,\tlogin_date) VALUES(?, NOW())";
      Connection conn = new connect().getConnection();
      PreparedStatement pre = conn.prepareStatement(sql);
      pre.setInt(1, user_id);
      
      pre.executeUpdate();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
    */
  }
}
