package Form;

import dialog.DialogConnectServer;
import dialog.DialogLogin;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.EventQueue;
import java.awt.Font;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Locale;
import javax.swing.ImageIcon;
import javax.swing.JDesktopPane;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.UIManager;
import javax.swing.border.EmptyBorder;
import util.FileConnect;
import util.ServerConnexion;
import Model.SocketClient;
import Model.SocketCuisinier;
import java.util.ArrayList;
import javax.swing.DefaultListModel;
import shared.Commande;

import com.itextpdf.text.BaseColor;
import com.itextpdf.text.Document;
import com.itextpdf.text.DocumentException;
import com.itextpdf.text.Element;
import com.itextpdf.text.Paragraph;
import com.itextpdf.text.pdf.PdfPCell;
import com.itextpdf.text.pdf.PdfPTable;
import com.itextpdf.text.pdf.PdfWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import shared.Message;

public class MainApp extends JFrame
{
  public JPanel contentPane;
  static public JDesktopPane desktopPane;
  public static JMenu menuPlat;
  public static JMenu menuCommande;
  public static JMenu menuAbout;
  
  public static JMenu menuClient;
  public static JMenu menuCommandeGestion;
  public static JMenu menuPayer;
  
  public static MainApp MainForm;
  public DialogLogin dialogLogin;
  public static JMenuBar menuBar;
  public static MainApp frame;
  
  
  public SocketClient client;
  public SocketCuisinier cuisinier;
  public int port;
  public String serverAddr, username, password;
  public Thread clientThread;
  public Thread cuisinierThread;
  public DefaultListModel modelClient;
  public DefaultListModel modelCuisinier;
  
  public ArrayList<Commande> listeCommandeDemandes_Cuisinier = new ArrayList<Commande>();
  public ArrayList<Commande> listeCommandeEnCours_Cuisinier = new ArrayList<Commande>();
  public ArrayList<Commande> listeCommandeTermines_Cuisinier = new ArrayList<Commande>();
  
  public ArrayList<Commande> listeCommandeEnCours_Client = new ArrayList<Commande>();
  public ArrayList<Commande> listeCommandeTermines_Client = new ArrayList<Commande>();
  
  public static void main(String[] args)
  {
    try
    {
      Locale.setDefault(Locale.FRENCH);
      String name = "com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel";
      UIManager.setLookAndFeel(name);
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
    EventQueue.invokeLater(new Runnable()
    {
      @Override
      public void run()
      {
        try
        {
          frame = new MainApp();
          frame.setVisible(true);  
          File file = new File("./images");
            if (!file.exists()) 
            {
                    if (file.mkdir()) 
                    {
                            System.out.println("Directory is created!");
                    } 
                    else 
                    {
                            System.out.println("Failed to create directory!");
                    }
            }
        }
        catch (Exception e)
        {
          e.printStackTrace();
        }
      }
    });
  }
  
  public MainApp()
  {
        MainForm = this;
        modelClient = new DefaultListModel();
        modelClient.addElement("MultiCast");
        
        modelCuisinier = new DefaultListModel();
        modelCuisinier.addElement("MultiCast");
        
        menuPlat = new JMenu("Gestion Plats");
        menuCommande = new JMenu("Gestion Commandes");
        menuAbout = new JMenu("About");
        
        menuClient = new JMenu("Commander");
        menuCommandeGestion = new JMenu("Status Commandes");
        menuPayer = new JMenu("Payer");
        
        
      addWindowListener(new WindowAdapter()
    {
      @Override
      public void windowOpened(WindowEvent arg0)
      {
        MainApp.menuPlat.setVisible(false);
        MainApp.menuCommande.setVisible(false);
        MainApp.menuAbout.setVisible(false);
        
        
        FileConnect Fileconn = new FileConnect();
        ServerConnexion conn = Fileconn.read();
                
        if (conn == null)
        {
                DialogConnectServer dc = new DialogConnectServer();
                dc.setVisible(true);
                
                MainForm.serverAddr = conn.getHost();
                MainForm.port = Integer.parseInt(conn.getPort());
                
        }
        else if (!DialogLogin.login)
        {
                    MainForm.serverAddr = conn.getHost();
                    MainForm.port = Integer.parseInt(conn.getPort());
                    dialogLogin = new DialogLogin(MainForm, true);
                    //dialogLogin.setVisible(true);
                   
        }
      }
    });
    setTitle("JRestau V.1 ENSAS");
    setIconImage(Toolkit.getDefaultToolkit().getImage(MainApp.class.getResource("/images/office_women_red.png")));
    setExtendedState(6);
    setDefaultCloseOperation(3);
    setBounds(100, 100, 450, 300);
    
    menuBar = new JMenuBar();
    
    this.contentPane = new JPanel();
    this.contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
    this.contentPane.setLayout(new BorderLayout(0, 0));
    setContentPane(this.contentPane);
    
    this.desktopPane = new JDesktopPane();
    this.contentPane.add(this.desktopPane, "Center");
  }
  

   public void ConstructMenuCuisinier()
  { 
    menuPlat.setIcon(new ImageIcon(MainApp.class.getResource("/images/plat.png")));
    menuPlat.setFont(new Font("Tahoma", 1, 14));
    menuBar.add(menuPlat);
    
    JMenuItem MenuItem_AjoutPlat = new JMenuItem("Ajouter Plats");
    MenuItem_AjoutPlat.setFont(new Font("Tahoma", 1, 14));
    MenuItem_AjoutPlat.setIcon(new ImageIcon(MainApp.class.getResource("/images/add.png")));
    MenuItem_AjoutPlat.addActionListener(new ActionListener()
    {
      @Override
      public void actionPerformed(ActionEvent e)
      {
        AjoutPlat_Form fc = new AjoutPlat_Form(MainForm);
        fc.setVisible(true);
        MainApp.desktopPane.add(fc);
      }
    });
    menuPlat.add(MenuItem_AjoutPlat);
    
    JMenuItem ModifierSuppPlat_item = new JMenuItem("Modifier/Supprimer Plats");
    ModifierSuppPlat_item.setFont(new Font("Tahoma", 1, 14));
    ModifierSuppPlat_item.setIcon(new ImageIcon(MainApp.class.getResource("/images/process.png")));
    ModifierSuppPlat_item.addActionListener(new ActionListener()
    {
      @Override
      public void actionPerformed(ActionEvent arg0)
      {
        UpdatePlat_Form fs = new UpdatePlat_Form(MainForm);
        fs.setVisible(true);
        MainApp.desktopPane.add(fs);
      }
    });
    menuPlat.add(ModifierSuppPlat_item);
    
    JMenuItem mntmExit = new JMenuItem("Exit");
    mntmExit.addActionListener(new ActionListener()
    {
      @Override
      public void actionPerformed(ActionEvent arg0)
      {
        System.exit(0);
      }
    });
    mntmExit.setIcon(new ImageIcon(MainApp.class.getResource("/images/exit.png")));
    mntmExit.setFont(new Font("Tahoma", 1, 14));
    menuPlat.add(mntmExit);
    
    
    menuCommande.setIcon(new ImageIcon(MainApp.class.getResource("/images/setup.png")));
    menuCommande.setFont(new Font("Tahoma", 1, 14));
    menuBar.add(menuCommande);
    
    JMenuItem CommandeDemande_Item = new JMenuItem("Commandes Demandéee");
    CommandeDemande_Item.setIcon(new ImageIcon(MainApp.class.getResource("/images/demande.png")));
    CommandeDemande_Item.setFont(new Font("Tahoma", 1, 14));
    CommandeDemande_Item.addActionListener(new ActionListener()
    {
      @Override
      public void actionPerformed(ActionEvent arg0)
      {
        CommandesDemandes_Form frc = new CommandesDemandes_Form(MainForm);
        frc.setVisible(true);
        MainApp.desktopPane.add(frc);
      }
    });
    menuCommande.add(CommandeDemande_Item);
    
    JMenuItem CommandeEnCours_Item = new JMenuItem("Commandes En Cours de Traitement");
    CommandeEnCours_Item.setIcon(new ImageIcon(MainApp.class.getResource("/images/EnCours.png")));
    CommandeEnCours_Item.setFont(new Font("Tahoma", 1, 14));
    CommandeEnCours_Item.addActionListener(new ActionListener()
    {
      @Override
      public void actionPerformed(ActionEvent arg0)
      {
        CommandeEnCours_Form frc = new CommandeEnCours_Form(MainForm);
        frc.setVisible(true);
        MainApp.desktopPane.add(frc);
      }
    });
    menuCommande.add(CommandeEnCours_Item);
    
    JMenuItem CommandeTermine_Item = new JMenuItem("Commandes Términé");
    CommandeTermine_Item.setIcon(new ImageIcon(MainApp.class.getResource("/images/Termine.png")));
    CommandeTermine_Item.setFont(new Font("Tahoma", 1, 14));
    CommandeTermine_Item.addActionListener(new ActionListener()
    {
      @Override
      public void actionPerformed(ActionEvent arg0)
      {
        CommandesTermine_Form frc = new CommandesTermine_Form(MainForm);
        frc.setVisible(true);
        MainApp.desktopPane.add(frc);
      }
    });
    menuCommande.add(CommandeTermine_Item);

    
    menuAbout.setIcon(new ImageIcon(MainApp.class.getResource("/images/info.png")));
    menuAbout.setFont(new Font("Tahoma", 1, 14));
    menuBar.add(menuAbout);
    
    JMenuItem mntmContactTo = new JMenuItem("Contact");
    mntmContactTo.addActionListener(new ActionListener()
    {
      @Override
      public void actionPerformed(ActionEvent arg0)
      {
        AboutCantact_Form fc = new AboutCantact_Form();
        fc.setVisible(true);
        MainApp.desktopPane.add(fc);
      }
    });
    mntmContactTo.setForeground(new Color(255, 0, 0));
    mntmContactTo.setIcon(new ImageIcon(MainApp.class.getResource("/images/help.png")));
    mntmContactTo.setFont(new Font("Tahoma", 1, 14));
    menuAbout.add(mntmContactTo);
    
    
    MainApp.menuPlat.setVisible(true);
    MainApp.menuCommande.setVisible(true);
    MainApp.menuAbout.setVisible(true);
        
    frame.setJMenuBar(menuBar);
    setTitle("JCuisinier - "+cuisinier.getUsername());
  }
  
  
  public void ConstructMenuClient()
  {
    
    menuClient.setIcon(new ImageIcon(MainApp.class.getResource("/images/office_women_glasses.png")));
    menuClient.setFont(new Font("Tahoma", 1, 14));
    menuBar.add(menuClient);
    
    JMenuItem MenuItem_CommandePlat = new JMenuItem("Commander Plats");
    MenuItem_CommandePlat.setFont(new Font("Tahoma", 1, 14));
    MenuItem_CommandePlat.setIcon(new ImageIcon(MainApp.class.getResource("/images/add.png")));
    MenuItem_CommandePlat.addActionListener(new ActionListener()
    {
      @Override
      public void actionPerformed(ActionEvent e)
      {
        CommandePlat_Form fc = new CommandePlat_Form(MainForm);
        fc.setVisible(true);
        MainApp.desktopPane.add(fc);
      }
    });
    menuClient.add(MenuItem_CommandePlat);
    
    JMenuItem mntmExit = new JMenuItem("Exit");
    mntmExit.addActionListener(new ActionListener()
    {
      @Override
      public void actionPerformed(ActionEvent arg0)
      {
        System.exit(0);
      }
    });
    mntmExit.setIcon(new ImageIcon(MainApp.class.getResource("/images/exit.png")));
    mntmExit.setFont(new Font("Tahoma", 1, 14));
    menuClient.add(mntmExit);
    
    menuCommandeGestion.setIcon(new ImageIcon(MainApp.class.getResource("/images/Status.png")));
    menuCommandeGestion.setFont(new Font("Tahoma", 1, 14));
    menuBar.add(menuCommandeGestion);
    
    JMenuItem MenuItem_CommandeEnCours = new JMenuItem("Commandes En Cours");
    MenuItem_CommandeEnCours.setFont(new Font("Tahoma", 1, 14));
    MenuItem_CommandeEnCours.setIcon(new ImageIcon(MainApp.class.getResource("/images/EnCours.png")));
    MenuItem_CommandeEnCours.addActionListener(new ActionListener()
    {
      @Override
      public void actionPerformed(ActionEvent e)
      {
        CommandeEnCours_Client fc = new CommandeEnCours_Client(MainForm);
        fc.setVisible(true);
        MainApp.desktopPane.add(fc);
      }
    });
    menuCommandeGestion.add(MenuItem_CommandeEnCours);
    
    JMenuItem MenuItem_CommandeServi = new JMenuItem("Commandes Servis");
    MenuItem_CommandeServi.setFont(new Font("Tahoma", 1, 14));
    MenuItem_CommandeServi.setIcon(new ImageIcon(MainApp.class.getResource("/images/Termine.png")));
    MenuItem_CommandeServi.addActionListener(new ActionListener()
    {
      @Override
      public void actionPerformed(ActionEvent e)
      {
        CommandeServi_Client fc = new CommandeServi_Client(MainForm);
        fc.setVisible(true);
        MainApp.desktopPane.add(fc);
      }
    });
    menuCommandeGestion.add(MenuItem_CommandeServi);
    
    menuPayer.setIcon(new ImageIcon(MainApp.class.getResource("/images/Cash.png")));
    menuPayer.setFont(new Font("Tahoma", 1, 14));
    menuBar.add(menuPayer);
    
    JMenuItem mntmPayer = new JMenuItem("Generer Facture");
    mntmPayer.addActionListener(new ActionListener()
    {
      @Override
      public void actionPerformed(ActionEvent arg0)
      {
          try {
              client.send(new Message("ListCommandeTermines_Client", client.getUsername(), "SendMeTheListOfCommandesTermines_Client", "SERVER"));
              GenerateFacture();
          } catch (FileNotFoundException ex) {
              Logger.getLogger(MainApp.class.getName()).log(Level.SEVERE, null, ex);
          }
      }
    });
    
    mntmPayer.setIcon(new ImageIcon(MainApp.class.getResource("/images/Payment.png")));
    mntmPayer.setFont(new Font("Tahoma", 1, 14));
    menuPayer.add(mntmPayer);
    //
    
    menuAbout.setIcon(new ImageIcon(MainApp.class.getResource("/images/info.png")));
    menuAbout.setFont(new Font("Tahoma", 1, 14));
    menuBar.add(menuAbout);
    
    JMenuItem mntmContactTo = new JMenuItem("Contact");
    mntmContactTo.addActionListener(new ActionListener()
    {
      @Override
      public void actionPerformed(ActionEvent arg0)
      {
        AboutCantact_Form fc = new AboutCantact_Form();
        fc.setVisible(true);
        MainApp.desktopPane.add(fc);
      }
    });
    mntmContactTo.setForeground(new Color(255, 0, 0));
    mntmContactTo.setIcon(new ImageIcon(MainApp.class.getResource("/images/help.png")));
    mntmContactTo.setFont(new Font("Tahoma", 1, 14));
    menuAbout.add(mntmContactTo);
    
        
    MainApp.menuClient.setVisible(true);
    MainApp.menuCommandeGestion.setVisible(true);
    MainApp.menuPayer.setVisible(true);
    MainApp.menuAbout.setVisible(true);
        
    frame.setJMenuBar(menuBar);
    setTitle("JClient - "+client.getUsername());
  }
  
  public void GenerateFacture() throws FileNotFoundException
  {
			final String titre="FACTURE CUISINE ENSAS - COMPTE "+client.getUsername();
                        double total = 0;
                            //CREATION DU FICHIER PDF
				try {
				Document document = new Document();
				PdfWriter.getInstance(document,new FileOutputStream("Facture.pdf"));
				document.open();
				PdfPTable table = new PdfPTable(4);
				PdfPCell cell = new PdfPCell(new Paragraph(titre));
				cell.setColspan(4);
				cell.setHorizontalAlignment(Element.ALIGN_CENTER);
				cell.setBackgroundColor(new BaseColor(193,255, 120));
				cell.setPadding(10.0f);
				table.addCell(cell);
				
				cell = new PdfPCell(new Paragraph("ID COMMANDE"));
				cell.setHorizontalAlignment(Element.ALIGN_CENTER);
				cell.setBackgroundColor(new BaseColor(193,255, 140));
				cell.setPadding(2.0f);
				table.addCell(cell);
				
				cell = new PdfPCell(new Paragraph("NOM PLAT"));
				cell.setHorizontalAlignment(Element.ALIGN_CENTER);
				cell.setBackgroundColor(new BaseColor(193,255, 140));
				cell.setPadding(5.0f);
				table.addCell(cell);
				
				cell = new PdfPCell(new Paragraph("QUANTITE"));
				cell.setHorizontalAlignment(Element.ALIGN_CENTER);
				cell.setBackgroundColor(new BaseColor(193,255, 140));
				cell.setPadding(5.0f);
				table.addCell(cell);
				
				cell = new PdfPCell(new Paragraph("PRIX"));
				cell.setHorizontalAlignment(Element.ALIGN_CENTER);
				cell.setBackgroundColor(new BaseColor(193,255, 255));
				cell.setPadding(5.0f);
				table.addCell(cell);
				
				
        
				for (int i=0;i<listeCommandeTermines_Client.size();i++)
				{       
                                        table.addCell(String.valueOf(listeCommandeTermines_Client.get(i).getID_Commande()));
					table.addCell(listeCommandeTermines_Client.get(i).getCommandePlat().getNom());
					table.addCell(String.valueOf(listeCommandeTermines_Client.get(i).getQuantite()));
					table.addCell(String.valueOf(listeCommandeTermines_Client.get(i).getCommandePlat().getPrix()));
                                        
                                        total = total + listeCommandeTermines_Client.get(i).getCommandePlat().getPrix();
				}
				
				cell = new PdfPCell(new Paragraph("TOTAL"));
				cell.setColspan(3);
				cell.setHorizontalAlignment(Element.ALIGN_CENTER);
				cell.setPadding(10.0f);
				table.addCell(cell);
				
				
				cell = new PdfPCell(new Paragraph(total+""));
				cell.setHorizontalAlignment(Element.ALIGN_CENTER);
				cell.setBackgroundColor(new BaseColor(193,255, 255));
				cell.setPadding(5.0f);
				table.addCell(cell);
				
				
				
					document.add(table);
					document.close();
                                        
				} catch (DocumentException e1) {
					
					e1.printStackTrace();
				}
				
				
				//FIN CREATION
				try {
					java.awt.Desktop.getDesktop().open(new File("Facture.pdf"));
				} catch (IOException e) {
					e.printStackTrace();
				}
    }
}
