package Model;

import Form.MainApp;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JLabel;

import com.javaswingcomponents.accordion.JSCAccordion;
import com.javaswingcomponents.accordion.tabrenderer.AccordionTabRenderer;
import com.javaswingcomponents.accordion.tabrenderer.GetTabComponentParameter;
import com.javaswingcomponents.framework.painters.configurationbound.LinearGradientColorPainter;

public class AccordionTabRendererMenu extends JLabel implements AccordionTabRenderer {

	private JSCAccordion accordion;
	
	private ImageIcon EntreeImage;
	private ImageIcon SoupeImage;
	private ImageIcon Plat_principalImage;
        private ImageIcon DessertImage;
        private ImageIcon BoissonImage;
        private ImageIcon ConfiserieImage;
	
	public AccordionTabRendererMenu() {
            
            EntreeImage = new ImageIcon(MainApp.class.getResource("/images/Entree.png"));
            SoupeImage = new ImageIcon(MainApp.class.getResource("/images/Soupe.png"));
            Plat_principalImage = new ImageIcon(MainApp.class.getResource("/images/Plat_principal.png"));
            DessertImage = new ImageIcon(MainApp.class.getResource("/images/Dessert.png"));
            BoissonImage = new ImageIcon(MainApp.class.getResource("/images/Boisson.png"));
            ConfiserieImage = new ImageIcon(MainApp.class.getResource("/images/Confiserie.png"));
	}
	
	@Override
	public JComponent getTabComponent(GetTabComponentParameter parameters) {
		//read the tabText from the parameter
		setText(parameters.tabText);
		//set the text color to white
		setForeground(Color.WHITE);
		//use a slightly smaller bold font
		setFont(getFont().deriveFont(Font.BOLD, 11f));
		//create a border to help align the label
		setBorder(BorderFactory.createEmptyBorder(0,8,0,0));
		//set the gap between the icon and the text to 8 pixels
		setIconTextGap(8);
		/*    "Entree", "Soupe", "Plat principal", "Dessert", "Boisson", "Confiserie"   */
                
		//set the appropriate image based on the tabText.
		if ("Entree".equals(parameters.tabText)) {
			setIcon(EntreeImage);
		}
		if ("Soupe".equals(parameters.tabText)) {
			setIcon(SoupeImage);
		}
		if ("Plat principal".equals(parameters.tabText)) {
			setIcon(Plat_principalImage);
		}
                if ("Dessert".equals(parameters.tabText)) {
			setIcon(DessertImage);
		}
                if ("Boisson".equals(parameters.tabText)) {
			setIcon(BoissonImage);
		}
                if ("Confiserie".equals(parameters.tabText)) {
			setIcon(ConfiserieImage);
		}
		
		//returns itself, which extends JLabel
		return this;
	}

	private LinearGradientColorPainter painter = new LinearGradientColorPainter();
	
	@Override
	protected void paintComponent(Graphics g) {
		//paints the background
		painter.setColorFractions(new float[]{
				0.0f, 0.49f, 0.5f, 0.51f, 0.8f,	1.0f});
		painter.setColors(new Color[]{
				new Color(167,163,189),new Color(143,138,169),
				new Color(131,126,160),new Color(116,110,146),
				new Color(119,113,148), new Color(138,133,164)});
		painter.paint((Graphics2D) g, new Rectangle(0, 0, getWidth(), getHeight()));
		
		//original color on g is stored and then later reset
		//this is to prevent clobbering of the Graphics object.
		Color originalColor = g.getColor();
		
		//paints a simple line on the bottom of the tab
		g.setColor(new Color(87,86,111));
		g.drawLine(0, getHeight()-1, getWidth(), getHeight()-1);
		
		g.setColor(originalColor);
		super.paintComponent(g);			
	}
	
	@Override
	public void setAccordion(JSCAccordion accordion) {
		this.accordion = accordion;
	}
}