package Model;

import Form.CommandeEnCours_Client;
import Form.CommandePlat_Form;
import Form.CommandeServi_Client;
import Form.MainApp;
import Form.NotificationCommandeRecu;
import shared.Message;
import java.io.*;
import java.net.*;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;
import net.sf.jcarrierpigeon.Notification;
import net.sf.jcarrierpigeon.NotificationQueue;
import net.sf.jcarrierpigeon.WindowPosition;
import sun.applet.Main;

public class SocketClient implements Runnable{
    
    public int port;
    public String serverAddr;
    public Socket socket=null;
    public MainApp ui;
    public ObjectInputStream In;
    public ObjectOutputStream Out;
    public String username, password;
    public NotificationQueue queue = new NotificationQueue();
    
    public SocketClient(MainApp frame) throws IOException{
        ui = frame; 
        this.serverAddr = ui.serverAddr; 
        this.port = ui.port;
        socket = new Socket(InetAddress.getByName(serverAddr), port);
            
        Out = new ObjectOutputStream(socket.getOutputStream());
        Out.flush();
        In = new ObjectInputStream(socket.getInputStream());
        if(socket!=null) System.out.println("Connexion socket client au serveur avec succes");
    }

    @Override
    public void run() {
        
        boolean keepRunning = true;
        while(keepRunning){
            try {
                Message msg = (Message) In.readObject();
                System.out.println("Reçu avec socket client : "+msg.toString());
                
                if(msg.type.equals("message"))
                {
                }
                else if(msg.type.equals("login"))
                {
                    switch (msg.corps) {
                        case "TRUE":
                            System.out.println("[SERVEUR > Moi] : Login Client accepté\n");
                            JOptionPane confirmation = new JOptionPane();
                            ImageIcon img = new ImageIcon(MainApp.class.getResource("/images/button_ok.png"));
                            confirmation.showMessageDialog(null, "Login Client accepté", "Acces Client", JOptionPane.INFORMATION_MESSAGE, img);
                            ui.dialogLogin.dispose();
                            ui.ConstructMenuClient();
                            break;
                        case "FALSE1":
                            System.out.println("[SERVEUR > Moi] : refusé, client est deja connecté\n");
                            JOptionPane erreur1 = new JOptionPane();
                            ImageIcon img1 = new ImageIcon(MainApp.class.getResource("/images/warning.png"));
                            erreur1.showMessageDialog(null, "refusé, client est deja connecté", "Acces Client", JOptionPane.ERROR_MESSAGE, img1);
                            break;
                        default:
                            System.out.println("[SERVEUR > Moi] : Login client refusé, info erroné\n");
                            JOptionPane erreur2 = new JOptionPane();
                            ImageIcon img2 = new ImageIcon(MainApp.class.getResource("/images/remove.png"));
                            erreur2.showMessageDialog(null, "Login client refusé, info erroné", "Acces Client", JOptionPane.ERROR_MESSAGE, img2);
                            break;
                    }
                }
                else if(msg.type.equals("newclient"))
                {
                    if(!msg.corps.equals(ui.username))
                    {
                        boolean exists = false;
                        for(int i = 0; i < ui.modelClient.getSize(); i++){
                            if(ui.modelClient.getElementAt(i).equals(msg.corps)){
                                exists = true; 
                                break;
                            }
                        }
                        if(!exists){ 
                            ui.modelClient.addElement(msg.corps);
                            playSound("in.wav");
                        }
                    }
                }
                else if(msg.type.equals("inscription"))
                {
                    if(msg.corps.equals("TRUE")){
                        
                        System.out.println("[SERVEUR > Moi] : Inscription client avec Succès\n");
                    }
                    else{
                        System.out.println("[SERVEUR > Moi] : Inscription client refusé, "+msg.recepteur+" existe déjà\n");
                    }
                }
                else if(msg.type.equals("signout"))
                {
                    if(msg.corps.equals(ui.username)){
                        System.out.println("["+ msg.emmeteur +" > Moi] : Bye\n");
                        
                        
                        for(int i = 1; i < ui.modelClient.size(); i++){
                            ui.modelClient.removeElementAt(i);
                        }
                        
                        ui.clientThread.stop();
                    }
                    else{
                        playSound("out.wav");
                        ui.modelClient.removeElement(msg.corps);
                        System.out.println("["+ msg.emmeteur +" > MultiCast] : "+ msg.corps +" est deconnecté\n");
                    }
                }
                else if(msg.type.equals("ListPlat"))
                {
                    if(msg.corps.equals("TRUE"))
                    {
                        System.out.println("[SERVEUR > Client] : Reception Liste Plats\n");
                        CommandePlat_Form.listePlats = msg.listePlats;
                        System.out.println("Client - Importation liste Plats");
                    }
                    else
                    {
                        System.out.println("[SERVEUR > Client] : Erreur, Liste Plats vide\n");
                        JOptionPane.showMessageDialog(null, "Il n'y a aucun Plat disponible pour le moment", "Erreur", JOptionPane.ERROR_MESSAGE);
                    }
                }
                else if(msg.type.equals("ListCommandesEnCours_Client"))
                {
                       if(msg.corps.equals("TRUE"))
                       {
                       System.out.println("[SERVEUR > Client] : Reception Liste des commandes En Cours\n");
                       ui.listeCommandeEnCours_Client = msg.listeCommandes;
                       CommandeEnCours_Client.listeCommandeEnCours_Client = msg.listeCommandes;
                       
                        
                        DefaultTableModel   table = new DefaultTableModel();
                        table.setRowCount(CommandeEnCours_Client.listeCommandeEnCours_Client.size());
                        table.setColumnCount(4);
                        String[] p4={"ID Commande","Nom Client","Nom Plat","Quantité"};
                        table.setColumnIdentifiers(p4);
                        for (int i = 0; i < CommandeEnCours_Client.listeCommandeEnCours_Client.size(); i++) 
                        {
                                table.setValueAt("Commande N° "+(i+1), i, 0);
                                table.setValueAt(CommandeEnCours_Client.listeCommandeEnCours_Client.get(i).getNom_client(), i, 1);
                                table.setValueAt(CommandeEnCours_Client.listeCommandeEnCours_Client.get(i).getCommandePlat().getNom(), i, 2);
                                table.setValueAt(CommandeEnCours_Client.listeCommandeEnCours_Client.get(i).getQuantite(), i, 3);
                        }
                        CommandeEnCours_Client.table = table;
                        CommandeEnCours_Client.CommandesEnCoursClient_jTable.setModel(table);
                        System.out.println("creation liste Commandes en Cours coté Client");
                        }
                        else
                        {
                            System.out.println("[SERVEUR > Client] : Erreur, Liste Comande En Cours vide\n");
                            JOptionPane.showMessageDialog(null, "Il n'y a aucune Commande En Cours - Client", "Erreur", JOptionPane.ERROR_MESSAGE);
                        }
                }
                else if(msg.type.equals("ListCommandeTermines_Client"))
                {
                       if(msg.corps.equals("TRUE"))
                       {
                            System.out.println("[SERVEUR > Client] : Reception Liste des commandes Recu et Termine\n");
                            ui.listeCommandeTermines_Client = msg.listeCommandes;
                            CommandeServi_Client.listeCommandeTermines1 = msg.listeCommandes;


                             DefaultTableModel   table = new DefaultTableModel();
                             table.setRowCount(msg.listeCommandes.size());
                             table.setColumnCount(4);
                             String[] p4={"ID Commande","Nom Client","Nom Plat","Quantité"};
                             table.setColumnIdentifiers(p4);
                             for (int i = 0; i < msg.listeCommandes.size(); i++) 
                             {
                                     table.setValueAt("Commande N° "+msg.listeCommandes.get(i).getID_Commande(), i, 0);
                                     table.setValueAt(msg.listeCommandes.get(i).getNom_client(), i, 1);
                                     table.setValueAt(msg.listeCommandes.get(i).getCommandePlat().getNom(), i, 2);
                                     table.setValueAt(msg.listeCommandes.get(i).getQuantite(), i, 3);
                             }
                             CommandeServi_Client.table = table;
                             CommandeServi_Client.CommandesTermine_jTable.setModel(table);
                             System.out.println("creation liste Commandes Termine coté Client");
                        }
                        else
                        {
                            System.out.println("[SERVEUR > Client] : Erreur, Liste Comande recu vide\n");
                            JOptionPane.showMessageDialog(null, "Il n'y a aucune Commande recu - Termine", "Erreur", JOptionPane.ERROR_MESSAGE);
                        }
                }
                else if(msg.type.equals("NotificationCommandeRecu"))
                {
                       System.out.println("[SERVEUR > Client] : Commande servi\n");
                       NotificationCommandeRecu Alert_IncommingCommand =  new NotificationCommandeRecu(msg.mycommande);
                       Notification note1 = new Notification(Alert_IncommingCommand, WindowPosition.BOTTOMRIGHT, 25, 25, 5000);
                       queue.add(note1);
                }
                else if(msg.type.equals("CommanderPlat"))
                {
                    if(msg.corps.equals("TRUE"))
                    {
                            System.out.println("[SERVEUR > Client] : Commande Ajouté\n");
                            JOptionPane confirmation = new JOptionPane();
                            ImageIcon img = new ImageIcon(MainApp.class.getResource("/images/button_ok.png"));
                            confirmation.showMessageDialog(null, "Commande Ajouté avec succes", "Commander Plat", JOptionPane.INFORMATION_MESSAGE, img);
                            
                            
                    }
                    else
                    {
                        System.out.println("[SERVEUR > Client] : commande non ajouté\n");
                        JOptionPane.showMessageDialog(null, "Erreur, Commande non ajouté", "Erreur", JOptionPane.ERROR_MESSAGE);
                    }
                }
                else{
                    System.out.println("[SERVEUR > Moi] : message de type inconnu\n");
                }
            }
            catch(Exception ex) {
                keepRunning = false;
                //System.out.println("[Application > Moi] : problème de Connexion\n");
                for(int i = 1; i < ui.modelClient.size(); i++)
                {
                    ui.modelClient.removeElementAt(i);
                }
                
                ui.clientThread.stop();
                
                System.out.println("Exception SocketClient run()");
                ex.printStackTrace();
            }
        } 
    }
    
       public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }
    
    public void send(Message msg){
        try {
            Out.writeObject(msg);
            Out.flush();
            System.out.println("Envoyé avec socket client: "+msg.toString());
        } 
        catch (IOException ex) {
            System.out.println("Exception SocketClient send()");
            ex.printStackTrace();
        }
    }
    
    public void closeThread(Thread t){
        t = null;
    }
    
    public static synchronized void playSound(final String url) {
  new Thread(new Runnable() {
      
    @Override
    public void run() {
      try {
        Clip clip = AudioSystem.getClip();
        AudioInputStream inputStream;
          inputStream = AudioSystem.getAudioInputStream(Main.class.getResourceAsStream("/sounds/" + url));
        clip.open(inputStream);
        clip.start(); 
      } catch (Exception e) {
        System.err.println(e.getMessage());
      }
    }
  }).start();
}
}
