package Model;


import Form.CommandeEnCours_Form;
import Form.CommandesDemandes_Form;
import Form.CommandesTermine_Form;
import Form.IncommingDemands_Notification;
import Form.MainApp;
import Form.UpdatePlat_Form;
import shared.Message;
import java.io.*;
import java.net.*;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;
import net.sf.jcarrierpigeon.Notification;
import net.sf.jcarrierpigeon.NotificationQueue;
import net.sf.jcarrierpigeon.WindowPosition;
import sun.applet.Main;

public class SocketCuisinier implements Runnable{
    
    public int port;
    public String serverAddr;
    public Socket socket=null;
    public MainApp ui;
    public ObjectInputStream In;
    public ObjectOutputStream Out;
    public String username, password;
    public UpdatePlat_Form X;
    int int_Test = 0;
    public NotificationQueue queue = new NotificationQueue();
    
    public SocketCuisinier(MainApp frame) throws IOException {
        ui = frame; 
        this.serverAddr = ui.serverAddr; 
        this.port = ui.port;
        socket = new Socket(InetAddress.getByName(serverAddr), port);
            
        Out = new ObjectOutputStream(socket.getOutputStream());
        Out.flush();
        In = new ObjectInputStream(socket.getInputStream());
        if(socket!=null) System.out.println("Connexion socket cuisinier au serveur avec succes");
    }
    
    public void setGui_ListPlat(UpdatePlat_Form temp) {
        X = temp;
    }
            
    @Override
    public void run() {
        
        boolean keepRunning = true;
        while(keepRunning){
            try {
                Message msg = (Message) In.readObject();
                System.out.println("Reçu avec socket cuisinier : "+msg.toString());
                
                if(msg.type.equals("message"))
                {
                }
                else if(msg.type.equals("login"))
                {
                    switch (msg.corps) {
                        case "TRUE":
                            System.out.println("[SERVEUR > Moi] : Login cuisinier accepté\n");
                            JOptionPane confirmation = new JOptionPane();
                            ImageIcon img = new ImageIcon(MainApp.class.getResource("/images/button_ok.png"));
                            confirmation.showMessageDialog(null, "Login cuisinier accepté", "Acces Cuisinier", JOptionPane.INFORMATION_MESSAGE, img);
                            ui.dialogLogin.dispose();
                            ui.ConstructMenuCuisinier();
                            break;
                        case "FALSE1":
                            System.out.println("[SERVEUR > Moi] : refusé, cuisinier est deja connecté\n");
                            JOptionPane erreur1 = new JOptionPane();
                            ImageIcon img1 = new ImageIcon(MainApp.class.getResource("/images/warning.png"));
                            erreur1.showMessageDialog(null, "refusé, cuisinier est deja connecté", "Acces Cuisinier", JOptionPane.ERROR_MESSAGE, img1);
                            break;
                        default:
                            System.out.println("[SERVEUR > Moi] : Login cuisinier refusé, info erroné\n");
                            JOptionPane erreur2 = new JOptionPane();
                            ImageIcon img2 = new ImageIcon(MainApp.class.getResource("/images/remove.png"));
                            erreur2.showMessageDialog(null, "Login cuisinier refusé, info erroné", "Acces Cuisinier", JOptionPane.ERROR_MESSAGE, img2);
                            break;
                    }
                }
                else if(msg.type.equals("newcuisinier"))
                {
                    if(!msg.corps.equals(ui.username))
                    {
                        boolean exists = false;
                        for(int i = 0; i < ui.modelCuisinier.getSize(); i++){
                            if(ui.modelCuisinier.getElementAt(i).equals(msg.corps)){
                                exists = true; break;
                                
                            }
                        }
                        if(!exists){ 
                            ui.modelCuisinier.addElement(msg.corps);
                            playSound("in.wav");
                        }
                    }
                }
                else if(msg.type.equals("inscription"))
                {
                    if(msg.corps.equals("TRUE")){
                        
                        System.out.println("[SERVEUR > Moi] : Inscription cuisinier avec Succès\n");
                    }
                    else{
                        System.out.println("[SERVEUR > Moi] : Inscription cuisinier refusé, "+msg.recepteur+" existe déjà\n");
                    }
                }
                else if(msg.type.equals("AjoutPlat"))
                {
                    if(msg.corps.equals("TRUE")){
                        
                        System.out.println("[SERVEUR > Moi] : Ajout Plat avec succes\n");
                        JOptionPane confirmation = new JOptionPane();
                            ImageIcon img = new ImageIcon(MainApp.class.getResource("/images/button_ok.png"));
                            confirmation.showMessageDialog(null, "Ajout du plat avec succes", "Ajout Plat Cuisinier", JOptionPane.INFORMATION_MESSAGE, img);
                            
                    }
                    else{
                        System.out.println("[SERVEUR > Moi] : Erreur d'ajout de Plat\n");
                        JOptionPane erreur2 = new JOptionPane();
                            ImageIcon img2 = new ImageIcon(MainApp.class.getResource("/images/remove.png"));
                            erreur2.showMessageDialog(null, "Ajout du Plat Refusé", "Ajout Plat Cuisinier", JOptionPane.ERROR_MESSAGE, img2);
                            
                    }
                }
                else if(msg.type.equals("CommencerPreparerPlat"))
                {
                    if(msg.corps.equals("TRUE")){
                        
                        System.out.println("[SERVEUR > Cuisinier] : Commencer préparer commande avec succes\n");
                        JOptionPane confirmation = new JOptionPane();
                        ImageIcon img = new ImageIcon(MainApp.class.getResource("/images/button_ok.png"));
                        confirmation.showMessageDialog(null, "Commencement préparation du commande avec succes", "preparer commande par Cuisinier", JOptionPane.INFORMATION_MESSAGE, img);
                        
                    }
                    else{
                        System.out.println("[SERVEUR > Cuisinier] : Erreur de commencement prepa de commande\n");
                        JOptionPane erreur2 = new JOptionPane();
                        ImageIcon img2 = new ImageIcon(MainApp.class.getResource("/images/remove.png"));
                        erreur2.showMessageDialog(null, "Commencement préparation du commande Refusé", "preparer commande par Cuisinier", JOptionPane.ERROR_MESSAGE, img2);
                            
                    }
                }
                else if(msg.type.equals("SupprimerPlat"))
                {
                    if(msg.corps.equals("TRUE"))
                    {
                        
                        System.out.println("[SERVEUR > Moi] : suppression Plat avec succes\n");
                        JOptionPane confirmation = new JOptionPane();
                        ImageIcon img = new ImageIcon(MainApp.class.getResource("/images/button_ok.png"));
                        confirmation.showMessageDialog(null, "suppression du plat avec succes", "suppression Plat Cuisinier", JOptionPane.INFORMATION_MESSAGE, img);
                        
                        
                        DefaultTableModel   table = new DefaultTableModel();
                        table.setRowCount(msg.listePlats.size());
                        table.setColumnCount(4);
                        String[] p4={"Catégorie","Nom","Prix","Durée Prépa"};
                        table.setColumnIdentifiers(p4);
                        for (int i = 0; i < msg.listePlats.size(); i++) 
                        {
                                table.setValueAt(msg.listePlats.get(i).getCategorie(), i, 0);
                                table.setValueAt(msg.listePlats.get(i).getNom(), i, 1);
                                table.setValueAt(msg.listePlats.get(i).getPrix(), i, 2);
                                table.setValueAt(msg.listePlats.get(i).getDuree(), i, 3);
                        }
                        UpdatePlat_Form.table = table;
                        UpdatePlat_Form.Data_jTable.setModel(table);
                    }
                    else{
                        System.out.println("[SERVEUR > Moi] : Erreur de suppression de Plat\n");
                        JOptionPane erreur2 = new JOptionPane();
                        ImageIcon img2 = new ImageIcon(MainApp.class.getResource("/images/remove.png"));
                        erreur2.showMessageDialog(null, "suppression du Plat Refusé", "suppression Plat Cuisinier", JOptionPane.ERROR_MESSAGE, img2);   
                    }
                }
                else if(msg.type.equals("ListPlat"))
                {
                    if(msg.corps.equals("TRUE")){
                        
                        System.out.println("[SERVEUR > Moi] : Reception Liste Plats\n");
                        UpdatePlat_Form.listePlats = msg.listePlats;
                        
                        DefaultTableModel   table = new DefaultTableModel();
                        table.setRowCount(msg.listePlats.size());
                        table.setColumnCount(4);
                        String[] p4={"Catégorie","Nom","Prix","Durée Prépa"};
                        table.setColumnIdentifiers(p4);
                        for (int i = 0; i < msg.listePlats.size(); i++) 
                        {
                                table.setValueAt(msg.listePlats.get(i).getCategorie(), i, 0);
                                table.setValueAt(msg.listePlats.get(i).getNom(), i, 1);
                                table.setValueAt(msg.listePlats.get(i).getPrix(), i, 2);
                                table.setValueAt(msg.listePlats.get(i).getDuree(), i, 3);
                        }
                        UpdatePlat_Form.table = table;
                        System.out.println("creation liste table");
                    }
                    else
                    {
                        System.out.println("[SERVEUR > Moi] : Erreur, Liste Plats vide\n");
                        JOptionPane.showMessageDialog(null, "Il n'y a aucun Plat créée dans la base données", "Erreur", JOptionPane.ERROR_MESSAGE);
                    }
                }
                else if(msg.type.equals("ListCommandesDemandes"))
                {
                       if(msg.corps.equals("TRUE"))
                       {
                            System.out.println("[SERVEUR > Cuisinier] : Reception Liste des commandes demandés\n");
                            ui.listeCommandeDemandes_Cuisinier = msg.listeCommandes;
                            CommandesDemandes_Form.listeCommandeDemandes1 = msg.listeCommandes;


                             DefaultTableModel   table = new DefaultTableModel();
                             table.setRowCount(CommandesDemandes_Form.listeCommandeDemandes1.size());
                             table.setColumnCount(4);
                             String[] p4={"ID Commande","Nom Client","Nom Plat","Quantité"};
                             table.setColumnIdentifiers(p4);
                             for (int i = 0; i < CommandesDemandes_Form.listeCommandeDemandes1.size(); i++) 
                             {
                                     table.setValueAt("Commande N° "+CommandesDemandes_Form.listeCommandeDemandes1.get(i).getID_Commande(), i, 0);
                                     table.setValueAt(CommandesDemandes_Form.listeCommandeDemandes1.get(i).getNom_client(), i, 1);
                                     table.setValueAt(CommandesDemandes_Form.listeCommandeDemandes1.get(i).getCommandePlat().getNom(), i, 2);
                                     table.setValueAt(CommandesDemandes_Form.listeCommandeDemandes1.get(i).getQuantite(), i, 3);
                             }
                             CommandesDemandes_Form.table = table;
                             CommandesDemandes_Form.CommandeDemandees_jTable.setModel(table);
                             System.out.println("creation liste Commandes coté Cuisinier");
                        }
                        else
                        {
                            System.out.println("[SERVEUR > Cuisinier] : Erreur, Liste Comande vide\n");
                            JOptionPane.showMessageDialog(null, "Il n'y a aucune Commande recu", "Erreur", JOptionPane.ERROR_MESSAGE);
                        }
                }
                //ListCommandesEnCours
                else if(msg.type.equals("ListCommandesEnCours"))
                {
                       if(msg.corps.equals("TRUE"))
                       {
                            System.out.println("[SERVEUR > Cuisinier] : Reception Liste des commandes en Cours\n");
                            ui.listeCommandeEnCours_Cuisinier = msg.listeCommandes;
                            CommandeEnCours_Form.listeCommandeEnCours1 = msg.listeCommandes;


                             DefaultTableModel   table = new DefaultTableModel();
                             table.setRowCount(CommandeEnCours_Form.listeCommandeEnCours1.size());
                             table.setColumnCount(4);
                             String[] p4={"ID Commande","Nom Client","Nom Plat","Quantité"};
                             table.setColumnIdentifiers(p4);
                             for (int i = 0; i < CommandeEnCours_Form.listeCommandeEnCours1.size(); i++) 
                             {
                                     table.setValueAt("Commande N° "+CommandeEnCours_Form.listeCommandeEnCours1.get(i).getID_Commande(), i, 0);
                                     table.setValueAt(CommandeEnCours_Form.listeCommandeEnCours1.get(i).getNom_client(), i, 1);
                                     table.setValueAt(CommandeEnCours_Form.listeCommandeEnCours1.get(i).getCommandePlat().getNom(), i, 2);
                                     table.setValueAt(CommandeEnCours_Form.listeCommandeEnCours1.get(i).getQuantite(), i, 3);
                             }
                             CommandeEnCours_Form.table = table;
                             CommandeEnCours_Form.CommandeEnCours_jTable.setModel(table);
                             System.out.println("creation liste Commandes en cours coté Cuisinier");
                        }
                        else
                        {
                            System.out.println("[SERVEUR > Cuisinier] : Erreur, Liste Comande vide\n");
                            JOptionPane.showMessageDialog(null, "Il n'y a aucune Commande recu", "Erreur", JOptionPane.ERROR_MESSAGE);
                        }
                }
                else if(msg.type.equals("ListCommandeTermines"))
                {
                       if(msg.corps.equals("TRUE"))
                       {
                            System.out.println("[SERVEUR > Cuisinier] : Reception Liste des commandes Termine\n");
                            ui.listeCommandeTermines_Cuisinier = msg.listeCommandes;
                            CommandesTermine_Form.listeCommandeTermines1 = msg.listeCommandes;


                             DefaultTableModel   table = new DefaultTableModel();
                             table.setRowCount(msg.listeCommandes.size());
                             table.setColumnCount(4);
                             String[] p4={"ID Commande","Nom Client","Nom Plat","Quantité"};
                             table.setColumnIdentifiers(p4);
                             for (int i = 0; i < msg.listeCommandes.size(); i++) 
                             {
                                     table.setValueAt("Commande N° "+msg.listeCommandes.get(i).getID_Commande(), i, 0);
                                     table.setValueAt(msg.listeCommandes.get(i).getNom_client(), i, 1);
                                     table.setValueAt(msg.listeCommandes.get(i).getCommandePlat().getNom(), i, 2);
                                     table.setValueAt(msg.listeCommandes.get(i).getQuantite(), i, 3);
                             }
                             CommandesTermine_Form.table = table;
                             CommandesTermine_Form.CommandesTermine_jTable.setModel(table);
                             System.out.println("creation liste Commandes Termine coté Cuisinier");
                        }
                        else
                        {
                            System.out.println("[SERVEUR > Cuisinier] : Erreur, Liste Comande Termine vide\n");
                            JOptionPane.showMessageDialog(null, "Il n'y a aucune Commande Termine", "Erreur", JOptionPane.ERROR_MESSAGE);
                        }
                }
                //SpecificCommandesEnCoursDetails
                else if(msg.type.equals("SpecificCommandesEnCoursDetails"))
                {
                       System.out.println("[SERVEUR > Cuisinier] : Reception info Progresse bar Commande\n");
                       for(int i=0;i<ui.listeCommandeEnCours_Cuisinier.size();i++)
                       {
                           if(msg.mycommande.getID_Commande() == ui.listeCommandeEnCours_Cuisinier.get(i).getID_Commande())
                           {
                               ui.listeCommandeEnCours_Cuisinier.set(i, msg.mycommande);
                           }
                       }
                       
                       CommandeEnCours_Form.Progression_jProgressBar.setValue(msg.mycommande.getProgressValue());
                       CommandeEnCours_Form.TempsEcouleX_jLabel.setText(String.valueOf((msg.mycommande.getTempsEcoule()/1000))+"Secondes");
                       
                       //RefreshProgressBar_Thread.Com = msg.mycommande;
                       //RefreshProgressBar_Thread.Com = msg.mycommande;
                       //CommandeEnCours_Form.Temp_Commande = msg.mycommande;
                       
                }
                else if(msg.type.equals("NewIncommingCommande"))
                {
                       System.out.println("[SERVEUR > Cuisinier] : Reception Nouvelle Commande\n");
                       IncommingDemands_Notification Alert_IncommingCommand =  new IncommingDemands_Notification(msg.mycommande);
                       Notification note1 = new Notification(Alert_IncommingCommand, WindowPosition.BOTTOMRIGHT, 25, 25, 5000);
                       queue.add(note1);
                }
                else if(msg.type.equals("ModifierPlat"))
                {
                    if(msg.corps.equals("TRUE")){
                        
                        System.out.println("[SERVEUR > Moi] : modification est faite avec succes, get new list of dishes\n");
                        UpdatePlat_Form.listePlats = msg.listePlats; 
                        if(UpdatePlat_Form.listePlats.isEmpty())
                        {
	        		JOptionPane.showMessageDialog(null, "Il n'y a aucun Plat créée dans la base données", "Erreur", JOptionPane.ERROR_MESSAGE);
	        	}
                        JOptionPane confirmation = new JOptionPane();
                        ImageIcon img = new ImageIcon(MainApp.class.getResource("/images/button_ok.png"));
                        confirmation.showMessageDialog(null, "Modification du plat avec succes", "Modif Plat Cuisinier", JOptionPane.INFORMATION_MESSAGE, img);
                            
		        DefaultTableModel   table = new DefaultTableModel();
                        table.setRowCount(msg.listePlats.size());
                        table.setColumnCount(4);
                        String[] p4={"Catégorie","Nom","Prix","Durée Prépa"};
                        table.setColumnIdentifiers(p4);
                        for (int i = 0; i < msg.listePlats.size(); i++) 
                        {
                                table.setValueAt(msg.listePlats.get(i).getCategorie(), i, 0);
                                table.setValueAt(msg.listePlats.get(i).getNom(), i, 1);
                                table.setValueAt(msg.listePlats.get(i).getPrix(), i, 2);
                                table.setValueAt(msg.listePlats.get(i).getDuree(), i, 3);
                        }
                        UpdatePlat_Form.table = table;
                        UpdatePlat_Form.Data_jTable.setModel(table);
                    }
                    else
                    {
                        System.out.println("[SERVEUR > Moi] : Modification refusé\n");
                        JOptionPane.showMessageDialog(null, "Modification refusé", "Erreur", JOptionPane.ERROR_MESSAGE);
                    }
                }
                else if(msg.type.equals("signout"))
                {
                    if(msg.corps.equals(ui.username)){
                        System.out.println("["+ msg.emmeteur +" > Moi] : Bye\n");
                        
                        
                        for(int i = 1; i < ui.modelCuisinier.size(); i++){
                            ui.modelCuisinier.removeElementAt(i);
                        }
                        
                        ui.clientThread.stop();
                    }
                    else{
                        playSound("out.wav");
                        ui.modelCuisinier.removeElement(msg.corps);
                        System.out.println("["+ msg.emmeteur +" > MultiCast] : "+ msg.corps +" est deconnecté\n");
                    }
                }
                else{
                    System.out.println("[SERVEUR > Moi] : message de type inconnu\n");
                }
            }
            catch(Exception ex) {
                keepRunning = false;
                //System.out.println("[Application > Moi] : problème de Connexion\n");
                for(int i = 1; i < ui.modelCuisinier.size(); i++)
                {
                    ui.modelCuisinier.removeElementAt(i);
                }
                ex.printStackTrace();
                ui.cuisinierThread.stop();
                System.out.println("Exception SocketCuisinier run()");
                
            }
        } 
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }
    
    public void send(Message msg){
        try {
            Out.writeObject(msg);
            Out.flush();
            System.out.println("Envoyé avec socket cuisinier : "+msg.toString());
        } 
        catch (IOException ex) {
            System.out.println("Exception SocketCuisinier send()");
            ex.printStackTrace();
        }
    }
    
    public void closeThread(Thread t){
        t = null;
    }
    
    public static synchronized void playSound(final String url) {
  new Thread(new Runnable() {
      
    @Override
    public void run() {
      try {
        Clip clip = AudioSystem.getClip();
        AudioInputStream inputStream;
          inputStream = AudioSystem.getAudioInputStream(Main.class.getResourceAsStream("/sounds/" + url));
        clip.open(inputStream);
        clip.start(); 
      } catch (Exception e) {
        System.err.println(e.getMessage());
      }
    }
  }).start();
}
}
