
package com.server;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import shared.Message;


public class Socket_Cuisinier_Thread  extends Thread { 
	
    public Main_Server_Thread server = null;
    public int ID = -1;
    public String username = "";
    public Socket socket = null;
    public ObjectInputStream streamIn  =  null;
    public ObjectOutputStream streamOut = null;
    public Server_Gui ui;

    public Socket_Cuisinier_Thread(Main_Server_Thread _server, Socket _socket, ObjectInputStream _streamIn,ObjectOutputStream _streamOut)
    {  
    	super();
        server = _server;
        socket = _socket;
        ID     = socket.getPort();
        ui = _server.ui;
        streamIn = _streamIn;
        streamOut = _streamOut;
    }
    
    public void send(Message msg){
        try {
            streamOut.writeObject(msg);
            streamOut.flush();
            System.out.println("Envoyé avec socket cuisinier: "+msg.toString());
        } 
        catch (IOException ex) {
            System.out.println("Exception [SocketClient : send(...)]");
        }
    }
    
    public int getID(){  
	    return ID;
    }
   
    @SuppressWarnings("deprecation")
    @Override
	public void run()
    {  
    	ui.Log_jTextArea.append("\nCuisinier Thread " + ID + " running.");
        boolean keepRunning = true;  
        while (keepRunning)
          {
    	    try{  
                    Message msg = (Message) streamIn.readObject();
                    System.out.println("Reçu avec socket cuisinier : "+msg.toString());
                    server.handleCuisinier(ID, msg);
                
            }
            catch(Exception ioe){ 
                keepRunning = false;
            	System.out.println(ID + " Cuisinier ERROR reading: " + ioe.getMessage());
                ioe.printStackTrace();
                server.removeCuisinier(ID);
                stop();
                
            }
    }
        
    }
    
    public void open() throws IOException {  
        streamOut = new ObjectOutputStream(socket.getOutputStream());
        streamOut.flush();
        streamIn = new ObjectInputStream(socket.getInputStream());
    }
    public void close() throws IOException {  
    	if (socket != null)    socket.close();
        if (streamIn != null)  streamIn.close();
        if (streamOut != null) streamOut.close();
    }
}