package shared;

import com.server.Server_Gui;
import static java.lang.Thread.sleep;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Coder Mahdi 
 */
public class CommandeEnCours_Thread extends Commande implements Runnable{

    private Thread runner=null;
    private String ThreadName;
    private Commande myCommande;
    private double TimePreparationinMiliSecond;
    private int ProgressValue=0;
    private int TempsEcoule=0;  //  milliseconde
    private long ClackRate;
    
    public Server_Gui ui;
    public ConnexionDB db;
    public int ID;

    public CommandeEnCours_Thread() {
        
    }
    
    
    public CommandeEnCours_Thread(Commande C, Server_Gui ui, int ID) throws SQLException {
        this.myCommande = C;
        this.ui = ui;
        this.ID = ID;
        db = this.ui.MyConnexionDB;
        ThreadName = "Thread Commande n° "+C.getID_Commande();
        runner = new Thread(this, ThreadName);
        TimePreparationinMiliSecond = (myCommande.getQuantite()*(myCommande.getCommandePlat().getDuree()*60))*1000;
        ClackRate = (long)(TimePreparationinMiliSecond/100);
        
        if(db.AddCommandThread(this)) System.out.println("succes in adding command thread");
        else System.out.println("error in adding command thread");
        
        
        
        System.out.println("clockrate is : "+ClackRate);
    }

   public void start()
   {
       runner = new Thread(this, ThreadName);
       this.runner.start();
   }
    
    @Override
    public void run() {
        
            for (int i=ProgressValue; i<=100; i++)
            {
                ProgressValue = i;
                //System.out.println(runner.getName()+" : "+i+"%, temps ecoulé :"+TempsEcoule);
                try
                {
                    sleep(ClackRate);
                    TempsEcoule = (int)(TempsEcoule+ClackRate);
                }
                catch (InterruptedException err){}
                finally // db
                {
                    try {
                        if(!db.UpdateCommandThread(ThreadName, ProgressValue, TempsEcoule))
                        {
                            System.out.println("erreur update commande progress bar");
                        }
                    } catch (SQLException ex) {
                        Logger.getLogger(CommandeEnCours_Thread.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }
            }
            
        try {            
            //Traitement End of preparation of plat*
            // ThreadName
            String NewThreadName = ThreadName.replace("Thread Commande n° ", "");
            int newID = Integer.parseInt(NewThreadName);
            
            if(db.EndPreparationCommandeMoveTo3(newID) && db.RemoveCommandThread(this))
            {
                
                ui.server.LoadCommandsIntoArrays();
                
                for(int i = 0; i < ui.server.cuisiniersCount; i++)
                {
                    Message MessageCommandesEnCours = new Message("ListCommandesEnCours", "SERVER", "TRUE", "AllCuisinier");
                    MessageCommandesEnCours.setListeCommandes(ui.server.listeCommandeEnCours);
                    ui.server.cuisiniers[i].send(MessageCommandesEnCours);
                    
                    Message MessageCommandeTermines = new Message("ListCommandeTermines", "SERVER", "TRUE", "AllCuisinier");
                    MessageCommandeTermines.setListeCommandes(ui.server.listeCommandeTermines);
                    ui.server.cuisiniers[i].send(MessageCommandeTermines);
                }
                
                ui.server.LoadCommandsIntoArrays();
                ArrayList<Commande> listeCommandeByClient = new ArrayList<Commande>();
                String NameClient = db.getNameClientByCommandeID(newID);
                
                for(int i=0;i<ui.server.listeCommandeTermines.size();i++)
                {
                    Commande TempC = ui.server.listeCommandeTermines.get(i);
                    if(TempC.getNom_client().equals(NameClient))
                    {
                        listeCommandeByClient.add(TempC);
                    }
                }
                Message newM = new Message("ListCommandeTermines_Client", "SERVER", "TRUE", NameClient);
                newM.setListeCommandes(listeCommandeByClient);
                ui.server.clients[ui.server.findClientByName(NameClient)].send(newM);   // System.out.println("envoi : "+new Message("login", "SERVER", "TRUE", msg.emmeteur).toString());
                
                ui.server.LoadCommandsIntoArrays();
                ArrayList<Commande> listeCommandeAll12 = new ArrayList<Commande>();
                ArrayList<Commande> listeCommandeByClient1 = new ArrayList<Commande>();
                listeCommandeAll12.addAll(ui.server.listeCommandeDemandes);
                listeCommandeAll12.addAll(ui.server.listeCommandeEnCours);
                
                for(int i=0;i<listeCommandeAll12.size();i++)
                {
                    Commande TempC = listeCommandeAll12.get(i);
                    if(TempC.getNom_client().equals(NameClient))
                    {
                        listeCommandeByClient1.add(TempC);
                    }
                }
                Message newM1 = new Message("ListCommandesEnCours_Client", "SERVER", "TRUE", NameClient);
                newM1.setListeCommandes(listeCommandeByClient1);
                ui.server.clients[ui.server.findClientByName(NameClient)].send(newM1);   // System.out.println("envoi : "+new Message("login", "SERVER", "TRUE", msg.emmeteur).toString());
                
                Commande XCommande = db.getCommandeByCommandeID(newID);
                Message newM2 = new Message("NotificationCommandeRecu", "SERVER", "TRUE", NameClient,XCommande);
                ui.server.clients[ui.server.findClientByName(NameClient)].send(newM2);
            }
        } catch (SQLException ex) {
            Logger.getLogger(CommandeEnCours_Thread.class.getName()).log(Level.SEVERE, null, ex);
        }
        }

    public String getThreadName() {
        return ThreadName;
    }

    public void setThreadName(String ThreadName) {
        this.ThreadName = ThreadName;
    }

    public Commande getMyCommande() {
        return myCommande;
    }

    public void setMyCommande(Commande myCommande) {
        this.myCommande = myCommande;
    }

    public double getTimePreparationinMiliSecond() {
        return TimePreparationinMiliSecond;
    }

    public void setTimePreparationinMiliSecond(double TimePreparationinMiliSecond) {
        this.TimePreparationinMiliSecond = TimePreparationinMiliSecond;
    }

    public int getProgressValue() {
        return ProgressValue;
    }

    public void setProgressValue(int ProgressValue) {
        this.ProgressValue = ProgressValue;
    }

    public int getTempsEcoule() {
        return TempsEcoule;
    }

    public void setTempsEcoule(int TempsEcoule) {
        this.TempsEcoule = TempsEcoule;
    }

    public long getClackRate() {
        return ClackRate;
    }

    public void setClackRate(long ClackRate) {
        this.ClackRate = ClackRate;
    }

    public ConnexionDB getDb() {
        return db;
    }

    public void setDb(ConnexionDB db) {
        this.db = db;
    }

    public Thread getRunner() {
        return runner;
    }

    public void setRunner(Thread runner) {
        this.runner = runner;
    }

    public Server_Gui getUi() {
        return ui;
    }

    public void setUi(Server_Gui ui) {
        this.ui = ui;
    }
    
    
    @Override
    public String toString() {
        return "CommandeEnCours_Thread{" + "ThreadName=" + ThreadName + ", TimePreparationinMiliSecond=" + TimePreparationinMiliSecond + ", ProgressValue=" + ProgressValue + ", TempsEcoule=" + TempsEcoule + ", ClackRate=" + ClackRate + '}';
    }
    
    
}
